/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.extension.motorcontrol;

import org.fortiss.af3.component.model.OutputPort;
import org.fortiss.af3.platform.language.executable.ExecutableBase;
import org.fortiss.af3.platform.raspberry.generator.framework.IWriteableGeneratorExtension;
import org.fortiss.af3.platform.raspberry.model.motorcontrol.MotorControlOutput;

/**
 * {@link ExecutableBase} for {@link MotorControlOutput}.
 * 
 * @author hoelzl
 */
public class MotorControlOutputGeneratorExtension extends
		MotorControlGeneratorExtensionBase<MotorControlOutput> implements
		IWriteableGeneratorExtension {
	/** Constructor. */
	public MotorControlOutputGeneratorExtension(MotorControlOutput modelElement) {
		super(modelElement);
	}

	/** {@inheritDoc} */
	@Override
	public String getWriteCode(OutputPort logicalSignal, String value) {
		return "setVelocity(" + value + ");\n";
	}

	/** {@inheritDoc} */
	@Override
	public String getNoValWriteCode(OutputPort logicalSignal) {
		return ";\n";
	}
}
