/*-------------------------------------------------------------------------+
| Copyright 2018 fortiss GmbH                                              |
|                                                                          |
| Licensed under the Apache License, Version 2.0 (the "License");          |
| you may not use this file except in compliance with the License.         |
| You may obtain a copy of the License at                                  |
|                                                                          |
|    http://www.apache.org/licenses/LICENSE-2.0                            |
|                                                                          |
| Unless required by applicable law or agreed to in writing, software      |
| distributed under the License is distributed on an "AS IS" BASIS,        |
| WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| See the License for the specific language governing permissions and      |
| limitations under the License.                                           |
+--------------------------------------------------------------------------*/
package org.fortiss.af3.platform.raspberry.generator.extension.v2v;

import org.fortiss.af3.component.model.OutputPort;
import org.fortiss.af3.platform.raspberry.generator.framework.IWriteableGeneratorExtension;
import org.fortiss.af3.platform.raspberry.model.v2v.V2VPlatoonOutput;

/** Executable for controlcenter {@link V2VPlatoonOutput}. */
public class V2VPlatoonOutputGeneratorExtension extends V2VGeneratorExtensionBase<V2VPlatoonOutput>
		implements IWriteableGeneratorExtension {
	/** Constructor. */
	public V2VPlatoonOutputGeneratorExtension(V2VPlatoonOutput modelElement) {
		super(modelElement);
	}

	/** {@inheritDoc} */
	@Override
	public String getWriteCode(OutputPort logicalSignal, String value) {

		return "af3_v2v_send_msg(V2V_MSG_TYPE_PLATOON, (uint8_t*) &" + value + " ) ;\n";

	}

	/** {@inheritDoc} */
	@Override
	public String getNoValWriteCode(OutputPort logicalSignal) {
		// return "af3_cc_send_noval(\"" + logicalSignal.getName() +
		// "\" , local_logical_clock );\n";
		return null;
	}
}
